package com.company.singlevalueholderexception.entity

import io.jmix.core.entity.annotation.JmixGeneratedValue
import io.jmix.core.metamodel.annotation.DependsOnProperties
import io.jmix.core.metamodel.annotation.JmixEntity
import io.jmix.core.metamodel.annotation.JmixProperty
import java.util.*
import javax.persistence.*

@JmixEntity
@Table(name = "INVOICE", indexes = [
    Index(name = "IDX_INVOICE_FROM_ID", columnList = "FROM_ID"),
    Index(name = "IDX_INVOICE_TO_ID", columnList = "TO_ID")
])
@Entity(name = "Invoice")
open class Invoice {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    var id: UUID? = null

    @JoinColumn(name = "FROM_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    var from: Company? = null

    @JoinColumn(name = "TO_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    var to: Company? = null

    @Column(name = "TYPE_")
    var type: String? = null

    @JoinColumn(name = "PAID_BY_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    var paidBy: Employee? = null

    @Transient
    @JmixProperty
    @DependsOnProperties("to", "from", "type")
    fun getCompany(): Company? {
        return if (type != null) {
            if (type == "in") {
                from
            } else {
                to
            }
        } else null
    }

}